<?php
error_reporting(0);

function clearDir($dossier) {
	$ouverture=@opendir($dossier);
	if (!$ouverture) return;
	while($fichier=readdir($ouverture)) {
		if ($fichier == '.' || $fichier == '..') continue;
			if (is_dir($dossier."/".$fichier)) {
				$r=clearDir($dossier."/".$fichier);
				if (!$r) return false;
			}
			else {
				$r=@unlink($dossier."/".$fichier);
				if (!$r) return false;
			}
	}
closedir($ouverture);
$r=@rmdir($dossier);
if (!$r) return false;
	return true;
}
	
function Checkzip($file, $extension)
{
	echo "Start check extension files in $file\n";ob_flush();flush();
	$zip = zip_open($file);
	if ($zip)
	{
		while ($zip_entry = zip_read($zip)) //Pour chaque fichier contenu dans le fichier zip
		{
			if (zip_entry_filesize($zip_entry) > 0)
			{
				$nom_fichier = zip_entry_name($zip_entry);
				$pos = strrpos($nom_fichier, ".");
				if ($pos)
					{
					$ext=substr($nom_fichier,$pos+1);
					if ($ext && in_array(strtolower($ext), $extension))
						{
						echo "Fatal Error : file extension not allowed '$nom_fichier' -> ($ext)\n";ob_flush();flush();
						return 0;
						}
					}
			}
		}
		zip_close($zip);
	}
	return 1;
}

function unzip($file, $path='', $effacer_zip=false)
{
	
	echo "Start unzip ZIP file '$file' to '$path'\n";ob_flush();flush();
	$zip = zip_open($file);

	if ($zip)
	{
		while ($zip_entry = zip_read($zip)) //Pour chaque fichier contenu dans le fichier zip
		{
			if (zip_entry_filesize($zip_entry) > 0)
			{
				$complete_path = $path.dirname(zip_entry_name($zip_entry));

				/*On supprime les ventuels caractres spciaux et majuscules*/
				$nom_fichier = zip_entry_name($zip_entry);
				
				$complete_name = $path.$nom_fichier; //Nom et chemin de destination
				
				/*On affiche le nom du fichier dans le tableau*/
				//echo "$nom_fichier-----ok\n";
				//printf ("%-'-30s->ok\n",$nom_fichier);ob_flush();flush();
				
				if(!file_exists($complete_path))
				{
					$tmp = '';
					foreach(explode('/',$complete_path) AS $k)
					{
						$tmp .= $k.'/';

						if(!file_exists($tmp))
						{ mkdir($tmp, 0777); }
					}
				}

				/*On extrait le fichier*/
				if (zip_entry_open($zip, $zip_entry, "r"))
				{
					$fd = fopen($complete_name, 'w');

					fwrite($fd, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry)));

					fclose($fd);
					zip_entry_close($zip_entry);
					chmod($complete_name,0777);
				}
			}
		}

		zip_close($zip);

		/*On efface ventuellement le fichier zip d'origine*/
		if ($effacer_zip === true)
		unlink($file);
	}

	return 1;
}
?>